
function App(data) {
  let elem;
  const store = data.store;

  let textElem;
  let backwardsTextElem;
  let input;
  let input2;

  function construct() {
    elem = document.createElement('div');
    {
      textElem = document.createElement('div');
      elem.appendChild(textElem);

      input = new Input({ store });
      elem.appendChild(input.elem);

      elem.appendChild(document.createElement('br'));
      input2 = new Input({ store });
      elem.appendChild(input2.elem);

      elem.appendChild(document.createElement('br'));
      elem.appendChild(document.createElement('br'));
      backwardsTextElem = document.createElement('div');
      elem.appendChild(backwardsTextElem);
    }
    bind();
    update();
  }

  function update() {
    textElem.innerHTML = store.getValue() || 'Enter a value...';
    backwardsTextElem.innerHTML = reverse(store.getValue()) || 'This will be the value backwards...';
  }

  function enter() {}
  function exit() {}

  function destroy() {
    input.destroy();
    input2.destroy();
    unbind();
  }

  function bind() {
    store.on('value', update);
  }
  function unbind() {
    store.off('value', update);
  }

  function reverse(string){
    return string.split('').reverse().join('');
  }

  construct();
  return { elem, data, update, enter, exit, destroy };
}
