/*!
 * Duck unframework used in this codebase.
 * Duck
 * (c) 2020 Tom Knapp-Ramos
 * Released under the MIT License.
 */

////////////////////////////////////////////////////////////////
// main

const store = new Store({});
let app;
mount();

////////////////////////////////////////////////////////////////
// utils

function mount() {
  app = new App({ store });
  document.body.insertBefore(app.elem, document.body.firstChild);
  app.enter();
}
